import { Component, OnInit } from '@angular/core';
import { Prefix } from 'src/app/models/prefix.model';
import { PrefixService } from 'src/app/services/prefix.service';
import {FormControl} from '@angular/forms';
import {Observable} from 'rxjs';
import {map, startWith} from 'rxjs/operators';

@Component({
  selector: 'app-prefix-details',
  templateUrl: './prefix-details.component.html',
  styleUrls: ['./prefix-details.component.scss']
  
})
export class PrefixDetailsComponent implements OnInit {
  simpleprefixControl = new FormControl();
  simpleprefix:string[] = [];
  simpleprefixfilteredOptions: Observable<string[]>;
  
  subjectsControl = new FormControl();
  subjects:string[] = [];
  subjectsfilteredOptions: Observable<string[]>;
  
  verbs = [];
  objects = [];
  logic_con = [];

  //for the moment only one prefix can showed/updates
  currentprefix: Prefix  = {
    prefix: "",
    system_fun_item: "",
    state_or_verb: "",
    item_function_flow_statevalue: "",
    logical_expression: "",
    logic_connective: "",
    simple_prefix: "",
  };
  message = '';
  

  constructor(private prefixService: PrefixService) {
      this.simpleprefixfilteredOptions = this.simpleprefixControl.valueChanges.pipe(
        startWith(""),
        map(value => this._filter(this.simpleprefix, value))
      );
      this.subjectsfilteredOptions = this.subjectsControl.valueChanges.pipe(
        startWith(""),
        map(value => this._filter(this.subjects, value))
      );
     }

  ngOnInit(): void { this.getchoices(); }
   
  private _filter(data:string[], value: string): string[] {
    const filterValue = value.toLowerCase();

    return data.filter(option => option.toLowerCase().indexOf(filterValue) === 0);
  }


  getPrefix(prefix: any, id: string): void {
    this.prefixService.get(prefix, id)
      .subscribe(
        data => {
          this.currentprefix = data;
          console.log(data);
        },
        error => {
          console.log(error);
        });
  }

// to be done
  updateBoilerplate(): void {
    //this.simpleprefix = 
    /*this.prefixService.update()
      .subscribe(
        response => {
          console.log(response);
          this.message = response.message;
        },
        error => {
          console.log(error);
        });*/
  }
  

  getchoices(): void{
  this.prefixService.getsimpleprefix()
    .subscribe(
      data => {
        for (let x=0; x < data.length; x++ ){
        this.simpleprefix.push(data[x][1]);}
        //this.simpleprefix = data;
      },
      error => {
        console.log(error);
      });
  this.prefixService.getlogcon()
    .subscribe(
      data => {
        this.logic_con = data;
      },
      error => {
        console.log(error);
      });
  this.prefixService.getverb()
    .subscribe(
      data => {
        this.verbs = data;
      },
      error => {
        console.log(error);
      });
  this.prefixService.getsubject()
    .subscribe(
      data => {
        for (let x=0; x < data.length; x++ ){
          this.subjects.push(data[x][1]);}
        //this.subjects = data;
      },
      error => {
        console.log(error);
      });
  this.prefixService.getoobject()
    .subscribe(
      data => {
        this.objects = data;
      },
      error => {
        console.log(error);
      });
  }
}
